/*
 * ex: set ro:
 * DO NOT EDIT.
 * generated by smc (http://smc.sourceforge.net/)
 * from file : Commandable.sm
 */

#ifndef _H_COMMANDABLE_SM
#define _H_COMMANDABLE_SM


#define SMC_USES_IOSTREAMS

#include <statemap.h>

namespace artdaq
{
    // Forward declarations.
    class Main;
    class Main_Booted;
    class Main_Initialized;
    class Main_Default;
    class InitializedMap;
    class InitializedMap_Ready;
    class InitializedMap_InRun;
    class InitializedMap_Default;
    class InRunMap;
    class InRunMap_Running;
    class InRunMap_Paused;
    class InRunMap_Default;
    class CommandableState;
    class CommandableContext;
    class Commandable;

    class CommandableState :
        public statemap::State
    {
    public:

        CommandableState(const char *name, int stateId)
        : statemap::State(name, stateId)
        {};

        virtual void Entry(CommandableContext&) {};
        virtual void Exit(CommandableContext&) {};

        virtual void init(CommandableContext& context, fhicl::ParameterSet const& pset);
        virtual void pause(CommandableContext& context);
        virtual void reinit(CommandableContext& context, fhicl::ParameterSet const& pset);
        virtual void resume(CommandableContext& context);
        virtual void shutdown(CommandableContext& context);
        virtual void soft_init(CommandableContext& context, fhicl::ParameterSet const& pset);
        virtual void start(CommandableContext& context, art::RunID id);
        virtual void stop(CommandableContext& context);

    protected:

        virtual void Default(CommandableContext& context);
    };

    class Main
    {
    public:

        static Main_Booted Booted;
        static Main_Initialized Initialized;
    };

    class Main_Default :
        public CommandableState
    {
    public:

        Main_Default(const char *name, int stateId)
        : CommandableState(name, stateId)
        {};

        virtual void init(CommandableContext& context, fhicl::ParameterSet const& pset);
        virtual void start(CommandableContext& context, art::RunID id);
        virtual void stop(CommandableContext& context);
        virtual void pause(CommandableContext& context);
        virtual void resume(CommandableContext& context);
        virtual void shutdown(CommandableContext& context);
        virtual void soft_init(CommandableContext& context, fhicl::ParameterSet const& pset);
        virtual void reinit(CommandableContext& context, fhicl::ParameterSet const& pset);
    };

    class Main_Booted :
        public Main_Default
    {
    public:
        Main_Booted(const char *name, int stateId)
        : Main_Default(name, stateId)
        {};

        void Entry(CommandableContext&);
        void init(CommandableContext& context, fhicl::ParameterSet const& pset);
        void shutdown(CommandableContext& context);
    };

    class Main_Initialized :
        public Main_Default
    {
    public:
        Main_Initialized(const char *name, int stateId)
        : Main_Default(name, stateId)
        {};

        void init(CommandableContext& context, fhicl::ParameterSet const& pset);
        void shutdown(CommandableContext& context);
    };

    class InitializedMap
    {
    public:

        static InitializedMap_Ready Ready;
        static InitializedMap_InRun InRun;
    };

    class InitializedMap_Default :
        public CommandableState
    {
    public:

        InitializedMap_Default(const char *name, int stateId)
        : CommandableState(name, stateId)
        {};

        virtual void init(CommandableContext& context, fhicl::ParameterSet const& pset);
        virtual void start(CommandableContext& context, art::RunID id);
        virtual void stop(CommandableContext& context);
        virtual void pause(CommandableContext& context);
        virtual void resume(CommandableContext& context);
        virtual void shutdown(CommandableContext& context);
        virtual void soft_init(CommandableContext& context, fhicl::ParameterSet const& pset);
        virtual void reinit(CommandableContext& context, fhicl::ParameterSet const& pset);
    };

    class InitializedMap_Ready :
        public InitializedMap_Default
    {
    public:
        InitializedMap_Ready(const char *name, int stateId)
        : InitializedMap_Default(name, stateId)
        {};

        void init(CommandableContext& context, fhicl::ParameterSet const& pset);
        void shutdown(CommandableContext& context);
        void soft_init(CommandableContext& context, fhicl::ParameterSet const& pset);
        void start(CommandableContext& context, art::RunID id);
    };

    class InitializedMap_InRun :
        public InitializedMap_Default
    {
    public:
        InitializedMap_InRun(const char *name, int stateId)
        : InitializedMap_Default(name, stateId)
        {};

        void Exit(CommandableContext&);
        void stop(CommandableContext& context);
    };

    class InRunMap
    {
    public:

        static InRunMap_Running Running;
        static InRunMap_Paused Paused;
    };

    class InRunMap_Default :
        public CommandableState
    {
    public:

        InRunMap_Default(const char *name, int stateId)
        : CommandableState(name, stateId)
        {};

        virtual void init(CommandableContext& context, fhicl::ParameterSet const& pset);
        virtual void start(CommandableContext& context, art::RunID id);
        virtual void stop(CommandableContext& context);
        virtual void pause(CommandableContext& context);
        virtual void resume(CommandableContext& context);
        virtual void shutdown(CommandableContext& context);
        virtual void soft_init(CommandableContext& context, fhicl::ParameterSet const& pset);
        virtual void reinit(CommandableContext& context, fhicl::ParameterSet const& pset);
    };

    class InRunMap_Running :
        public InRunMap_Default
    {
    public:
        InRunMap_Running(const char *name, int stateId)
        : InRunMap_Default(name, stateId)
        {};

        void pause(CommandableContext& context);
        void stop(CommandableContext& context);
    };

    class InRunMap_Paused :
        public InRunMap_Default
    {
    public:
        InRunMap_Paused(const char *name, int stateId)
        : InRunMap_Default(name, stateId)
        {};

        void resume(CommandableContext& context);
        void stop(CommandableContext& context);
    };

    class CommandableContext :
        public statemap::FSMContext
    {
    public:

        CommandableContext(Commandable& owner)
        : FSMContext(Main::Booted),
          _owner(owner)
        {};

        CommandableContext(Commandable& owner, const statemap::State& state)
        : FSMContext(state),
          _owner(owner)
        {};

        virtual void enterStartState()
        {
            getState().Entry(*this);
            return;
        }

        Commandable& getOwner() const
        {
            return (_owner);
        };

        CommandableState& getState() const
        {
            if (_state == NULL)
            {
                throw statemap::StateUndefinedException();
            }

            return (dynamic_cast<CommandableState&>(*_state));
        };

        void init(fhicl::ParameterSet const& pset)
        {
            (getState()).init(*this, pset);
        };

        void pause()
        {
            (getState()).pause(*this);
        };

        void reinit(fhicl::ParameterSet const& pset)
        {
            (getState()).reinit(*this, pset);
        };

        void resume()
        {
            (getState()).resume(*this);
        };

        void shutdown()
        {
            (getState()).shutdown(*this);
        };

        void soft_init(fhicl::ParameterSet const& pset)
        {
            (getState()).soft_init(*this, pset);
        };

        void start(art::RunID id)
        {
            (getState()).start(*this, id);
        };

        void stop()
        {
            (getState()).stop(*this);
        };

    private:

        Commandable& _owner;
    };
}


#endif // _H_COMMANDABLE_SM

/*
 * Local variables:
 *  buffer-read-only: t
 * End:
 */
